/*Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-EPM042A1-1B
Display is Hardward SPI 4-Wire SPI Interface 
Tested and worked with:
Works with Arduino 1.6.0 IDE  
Works with Arduino DUE,Arduino mega2560,Arduino UNO Board
****************************************************/

#include <SPI.h>
#include "ER-EPM042A1-1B.h"
#include "imagedata.h"
#include "epdpaint.h"

#define COLORED     0
#define UNCOLORED   1

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  Epd epd;

  if (epd.Init() != 0) {
    Serial.print("e-Paper init failed");
    return;
  }

  /* This clears the SRAM of the e-paper display */
  epd.ClearFrameMemory(0xFF);   // bit set = white, bit reset = black

  /**
    * Due to RAM not enough in Arduino UNO, a frame buffer is not allowed.
    * In this case, a smaller image buffer is allocated and you have to 
    * update a partial display several times.
    * 1 byte = 8 pixels, therefore you have to set 8*N pixels at a time.
    */
  #if 1  
  unsigned char image[1500];
Paint paint(image, 0, 0);    //width should be the multiple of 8 
  //paint.SetRotate(ROTATE_0);
  paint.SetWidth(200);    // width should be the multiple of 8 
  paint.SetHeight(20);
 
  //For simplicity, the arguments are explicit numerical coordinates 
  paint.Clear(UNCOLORED);
  paint.DrawStringAt(0, 0, "Hello world!", &Font20, COLORED);
  epd.SetFrameMemory(paint.GetImage(), 60, 20, paint.GetWidth(), paint.GetHeight());

  paint.Clear(UNCOLORED);
  paint.DrawStringAt(0, 0, "buydisplay.com", &Font20, COLORED);
  epd.SetFrameMemory(paint.GetImage(), 60, 50, paint.GetWidth(), paint.GetHeight());

  
  paint.SetWidth(64);
  paint.SetHeight(64);

  paint.Clear(UNCOLORED);
  paint.DrawRectangle(0, 0, 40, 50, COLORED);
  paint.DrawLine(0, 0, 40, 50, COLORED);
  paint.DrawLine(40, 0, 0, 50, COLORED);
  epd.SetFrameMemory(paint.GetImage(), 72, 120, paint.GetWidth(), paint.GetHeight());
  
  paint.Clear(UNCOLORED);
  paint.DrawCircle(32, 32, 30, COLORED);
  epd.SetFrameMemory(paint.GetImage(), 200, 120, paint.GetWidth(), paint.GetHeight());

  paint.Clear(UNCOLORED);
  paint.DrawFilledRectangle(0, 0, 40, 50, COLORED);
  epd.SetFrameMemory(paint.GetImage(), 72, 200, paint.GetWidth(), paint.GetHeight());

  paint.Clear(UNCOLORED);
  paint.DrawFilledCircle(32, 32, 30, COLORED);
  epd.SetFrameMemory(paint.GetImage(), 200, 200, paint.GetWidth(), paint.GetHeight());

  /* This displays the data from the SRAM in e-Paper module */
  epd.DisplayFrame();
 delay(2000);
  #endif 
  
#if 1
  /* This displays an image */
  epd.SetFrameMemory(IMAGE_BUTTERFLY);  
  epd.DisplayFrame(); 
 delay(2000);
 
  epd.SendCommand(DISPLAY_UPDATE_CONTROL_1);
  epd.SendData(0x08);//Inverse RAM
   epd.DisplayFrame(); 
 delay(2000);
  
  #endif  
  
#if 1  

     epd.SendCommand(DISPLAY_UPDATE_CONTROL_1);
     epd.SendData(0x00);//Normal
     epd.SetFrameMemory(IMAGE_BUTTERFLY1);
      epd.DisplayFrame(); 
        delay(2000);  
        
   epd.SendCommand(DISPLAY_UPDATE_CONTROL_1);
  epd.SendData(0x08);//Inverse RAM
   epd.DisplayFrame(); 
   delay(2000);       
     
 #endif 
 
  delay(15000);
   epd.SendCommand(DISPLAY_UPDATE_CONTROL_1);
  epd.SendData(0x00);//Normal
  epd.ClearFrameMemory(0xFF);
  epd.DisplayFrame();  
  /* Deep sleep */
  epd.Sleep();
}

void loop() {
  // put your main code here, to run repeatedly:

}

